#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <mem.h>
#include <i86.h>
#include "mikmod\mikmod.h"
#include "video.h"
#include "music.h"
#include "misc.h"
#include "image.h"
#include "resource.h"
#include "poly2d.h"
#include "smooth.h"
#include "3d.h"
#include "parts.h"

int frames;

void main( int argc, char* argv[] ) {

  resInit( argv[0] );

  Startup( argc > 1 );

  musLoadModule("aladeroc.s3m");
//  musSAMPLE sample1 = musLoadSample("b1.wav");
//  musSAMPLE sample2 = musLoadSample("b2.wav");
  musStartMusic();
  frames = 0;
  uint start = miscTimer(), end;

/*
  PAGE color = vidAllocPage( true );
  PAGE bw = vidAllocPage( true );
  int i;

  Image colorpic( "backgrnd.raw", STRETCH_SCREEN ), texture( "texture.raw" ),
        dither( "dither.raw" );
  vidSetPalette( dither.palette );
  vidClearPage(bw,128);

  short* zbuffer = new short[vidPageSize];

  FILE* fp;
  fp = resOpenFile( argv[1] );
  TCollection ascs;
  FacedObject* f;
  while( !resEof(fp) ) {
    char* s = getToken( fp, "\r\n ,\t" );
    if( resEof(fp) ) break;
    f = new FacedObject( MAP_XY|NO_SHADOW|MAP_NOSCALE);
    FILE* fp1 = resOpenFile(s);
    f->ImportASC( fp1, VID_MAX_SIZE_Y*0.5, &colorpic, MAP_XY );
    f->Prepare();
    ascs.Insert(f);
  };
  resClose(fp);

  FacedObject asc(*(FacedObject*)ascs.At(0));
  int j=1, n=0; i=0;
  int lx=0,ly=0,lxs=10,lys=7, zs = 20;
  for(;;) {
    asc.Morph( *(FacedObject*)ascs.At(i), *(FacedObject*)ascs.At(j), n, 20, false );
    n++;
    if( n == 20 ) {
      i=j;
      j=(++j) % ascs.Count;
      n = 0;
    }
    memset( zbuffer, 0x8080, vidPageSize*sizeof(ushort) );
    int ll=(560-sqrt(sqr(lx+VID_MAX_SIZE_X/2)+sqr(ly+VID_MAX_SIZE_Y/2)))*65536*0.75,
        lr=(560-sqrt(sqr(lx-VID_MAX_SIZE_X/2)+sqr(ly+VID_MAX_SIZE_Y/2)))*65536*0.75,
        lls=(560-sqrt(sqr(lx+VID_MAX_SIZE_X/2)+sqr(ly-VID_MAX_SIZE_Y/2)))*65536*0.75,
        lrs=(560-sqrt(sqr(lx-VID_MAX_SIZE_X/2)+sqr(ly-VID_MAX_SIZE_Y/2)))*65536*0.75;
    lls = ((lls-ll)/vidSizeY);
    lrs = ((lrs-lr)/vidSizeY);
    for( int y=0; y<vidSizeY; y++ ) {
      FillScanLine(bw+vidBytesPerLine*y,ll<<8,((lr-ll)/(vidSizeX+1))<<8);
      ll+=lls; lr+=lrs;
    }
//    vidCopyPage(color,colorpic.data);
    memset( color, 0, vidPageSize );
    asc.SetLightTo( lx,ly,1,0 );
    asc.rx++; asc.ry+=2; asc.rz;
    asc.Draw(zbuffer,color,bw);
    vidDitherPage(color,bw,vpage,dither.data);
    asc.dz += zs;
    if( asc.dz > 300 || asc.dz < 0 ) zs = -zs;
    if( abs(lx) >= VID_MAX_SIZE_X/5 ) lxs = -lxs;
    if( abs(ly) >= VID_MAX_SIZE_Y/5 ) lys = -lys;
    lx += lxs; ly += lys;
    frames++;
    vidFlipPage(&vpage,vpage1,vpage2);
  }

  goto __end__;
*/
  partInit();
  partTrees(25);
  partTitle(75);
  partFace(110);
  partFire(135);
  partFigs(200);
  partIndy(245);
  partCubes(280);
  partDone();

__end__:

  end = miscTimer()-start;

  Shutdown();
  printf( "Frames per second: %5.2f\n",
          frames*miscTimerRes/end );
}